/*****************************************************************************
 * BF70xPrngSim.c
 *****************************************************************************/

#include "adi_initialize.h"
#include "BF70xPrngSim.h"
#include <blackfin.h>
#include <stdio.h>
#include <string.h>

uint8_t keyBuff[128/8 * 2] = {0xe9, 0x63, 0xd0, 0xed, 0x9b, 0xf1, 0x7e, 0x16, 0xc2, 0xd8, 0xfa, 0x5a, 0x13, 0xc9, 0xb7, 0xa9};
uint32_t *kB = (uint32_t *)keyBuff;

uint8_t seedBuff[128/8 * 2] = {0xb6, 0x14, 0xf7, 0x49, 0x96, 0x4f, 0xf0, 0x9a, 0x27, 0x55, 0x01, 0x48, 0xbd, 0xf0, 0x55, 0x1e};
uint32_t *sB = (uint32_t *)seedBuff;

uint8_t dtBuff[128/8 * 2] = {0xd6, 0xc6, 0x5e, 0x8d, 0x8c, 0x9e, 0x29, 0x78, 0x2b, 0xe1, 0x42, 0xc4, 0xbf, 0xf7, 0xc4, 0x31};
uint32_t *dtB = (uint32_t *)dtBuff;

uint8_t  iBuff[128/8];
uint32_t *iB = (uint32_t *)iBuff;

uint8_t  randBuff[128/8];
uint32_t *rB = (uint32_t *)randBuff;

uint8_t  ivBuff[128/8];
uint32_t *ivB = (uint32_t *)ivBuff;

uint8_t  riBuff[128/8];
uint32_t *riB = (uint32_t *)riBuff;


char line[256]="";

int main(void)
{
	int i, j, k, outputCnt, lastK, cnt;
	unsigned long stat, *input, *output, resStat, len;
	FILE *outfp, *infp;
	char *resFgets;

	/**
	 * Initialize managed drivers and/or services that have been added to 
	 * the project.
	 * @return zero on success 
	 */
	adi_initComponents();
	
	infp = fopen("../src/ANSI931_AES128MCT.req", "r");
	outfp = fopen("output.rsp", "w");

	if(infp == NULL || outfp == NULL){
		printf("can't open input or output file\n");
		exit(0);
	}


	while(strncmp(line, "COUNT", 5)!=0){
		resFgets = fgets(line, sizeof(line), infp);

		fputs(line, outfp);
		if(resFgets == NULL || feof(infp))  // return if we reach end of file
				return 0;
	}

	if(strncmp(line, "COUNT", 5) == 0){
		cnt = strtoul(&line[8], 0, 10);
		printf("cnt = %d\n", cnt);
	}

	resFgets = fgets(line, sizeof(line), infp);
	while(line[0] != '\n' && resFgets != NULL){
		fputs(line, outfp);

		if(strncmp(line, "Key", 3) == 0){
			for(i=0; i<(128/8); i++)
				sscanf(&line[6+i*2], "%02x", &(((uint8_t *)keyBuff)[i]));
		}

		if(strncmp(line, "DT", 2) == 0){
			for(i=0; i<(128/8); i++)
				sscanf(&line[5+i*2], "%02x", &(((uint8_t *)dtBuff)[i]));
		}

		if(strncmp(line, "V", 1) == 0){
			for(i=0; i<(128/8); i++)
				sscanf(&line[4+i*2], "%02x", &(((uint8_t *)seedBuff)[i]));
		}

		resFgets = fgets(line, sizeof(line), infp);
	}


	/* reset engine and release */
	*pREG_PKTE0_CFG = 3;
	*pREG_PKTE0_CFG = 0;

	/* configure for Direct Host Mode */
	*pREG_PKTE0_CFG = 0;



	for(j=0; j<10000; j++){

		/*
		 *  I = e x K(DT)
		 */


		/* write Command Descriptor regs */
		*pREG_PKTE0_CTL_STAT = 0x1;                   /* host ready */
		*pREG_PKTE0_LEN      = 16 | 0x400000;         /* length =16.  Set  PE_READY=0, HOST_READY=1    */
		*pREG_PKTE0_CDSC_CNT = 1;                     /* cmd desc cnt =1.  Trigger PKTE to validate cmd desc */

		/* write state and SA Record regs */
		*pREG_PKTE0_SA_CMD0  = 0x0200f3c0;            /* aes encrypt */
		*pREG_PKTE0_SA_CMD1  = 0x02000000;            /* 128 bit ECB */


		/* write the key */
		*pREG_PKTE0_SA_KEY0 = kB[0];
		*pREG_PKTE0_SA_KEY1 = kB[1];
		*pREG_PKTE0_SA_KEY2 = kB[2];
		*pREG_PKTE0_SA_KEY3 = kB[3];

		*pREG_PKTE0_SA_RDY   = 1;                     /* trigger operation */

		/* write input */
		input = (unsigned long *)pREG_PKTE0_DATAIO_BUF;
		for (i=0; i<(128/32); i++)
			input[i] = dtB[i];

		/* set input buffer count.  the count needs to be rounded up length to **next** multiple of 4 if not already a mult of 4*/
		*pREG_PKTE0_INBUF_CNT = 16;

		/* poll status */
		stat = *pREG_PKTE0_STAT;
		while((stat & 0x200) == 0){
			for(i=0; i<100; i++);
			stat = *pREG_PKTE0_STAT;
		}


		/* collect output and acknowledge */
		output    = (unsigned long *)pREG_PKTE0_DATAIO_BUF;
		outputCnt = *pREG_PKTE0_STAT;
		outputCnt = (outputCnt & 0xffc00000) >> 22;    /* get number of words available */

		for(i=0; i<outputCnt; i++)
			iB[i] = *output++;

		*pREG_PKTE0_OUTBUF_CNT = outputCnt * 4;        /* acknowledge how many bytes were read from buffer */

		/* clean up */
		resStat = *pREG_PKTE0_CTL_STAT;
		len     = *pREG_PKTE0_LEN;
		*pREG_PKTE0_RDSC_CNT = 1;                      /* allows engine to accept new cmd desc's */


		/*
		 *  Random #
		 *  R = e x K(I xor V)
		 */


		/* I xor V */
		for(i=0; i<(128/32); i++)
			ivB[i] = iB[i] ^ sB[i];


		/* write Command Descriptor regs */
		*pREG_PKTE0_CTL_STAT = 0x1;                   /* host ready */
		*pREG_PKTE0_LEN      = 16 | 0x400000;         /* length =16.  Set  PE_READY=0, HOST_READY=1    */
		*pREG_PKTE0_CDSC_CNT = 1;                     /* cmd desc cnt =1.  Trigger PKTE to validate cmd desc */

		/* write state and SA Record regs */
		*pREG_PKTE0_SA_CMD0  = 0x0200f3c0;            /* aes encrypt */
		*pREG_PKTE0_SA_CMD1  = 0x02000000;            /* 128 bit ECB */


		/* write the key */
		*pREG_PKTE0_SA_KEY0 = kB[0];
		*pREG_PKTE0_SA_KEY1 = kB[1];
		*pREG_PKTE0_SA_KEY2 = kB[2];
		*pREG_PKTE0_SA_KEY3 = kB[3];

		*pREG_PKTE0_SA_RDY   = 1;                     /* trigger operation */

		/* write input */
		input = (unsigned long *)pREG_PKTE0_DATAIO_BUF;
		for (i=0; i<(128/32); i++)
			input[i] = ivB[i];

		/* set input buffer count.  the count needs to be rounded up length to **next** multiple of 4 if not already a mult of 4*/
		*pREG_PKTE0_INBUF_CNT = 16;

		/* poll status */
		stat = *pREG_PKTE0_STAT;
		while((stat & 0x200) == 0){
			for(i=0; i<100; i++);
			stat = *pREG_PKTE0_STAT;
		}


		/* collect output and acknowledge */
		output    = (unsigned long *)pREG_PKTE0_DATAIO_BUF;
		outputCnt = *pREG_PKTE0_STAT;
		outputCnt = (outputCnt & 0xffc00000) >> 22;    /* get number of words available */

		for(i=0; i<outputCnt; i++)
			rB[i] = *output++;

		*pREG_PKTE0_OUTBUF_CNT = outputCnt * 4;        /* acknowledge how many bytes were read from buffer */

		/* clean up */
		resStat = *pREG_PKTE0_CTL_STAT;
		len     = *pREG_PKTE0_LEN;
		*pREG_PKTE0_RDSC_CNT = 1;                      /* allows engine to accept new cmd desc's */


		/*
		 * V = e x K(R xor I)
		 */

		/* R xor I */
		for(i=0; i<(128/32); i++)
			riB[i] = rB[i] ^ iB[i];

		/* write Command Descriptor regs */
		*pREG_PKTE0_CTL_STAT = 0x1;                   /* host ready */
		*pREG_PKTE0_LEN      = 16 | 0x400000;         /* length =16.  Set  PE_READY=0, HOST_READY=1    */
		*pREG_PKTE0_CDSC_CNT = 1;                     /* cmd desc cnt =1.  Trigger PKTE to validate cmd desc */

		/* write state and SA Record regs */
		*pREG_PKTE0_SA_CMD0  = 0x0200f3c0;            /* aes encrypt */
		*pREG_PKTE0_SA_CMD1  = 0x02000000;            /* 128 bit ECB */


		/* write the key */
		*pREG_PKTE0_SA_KEY0 = kB[0];
		*pREG_PKTE0_SA_KEY1 = kB[1];
		*pREG_PKTE0_SA_KEY2 = kB[2];
		*pREG_PKTE0_SA_KEY3 = kB[3];

		*pREG_PKTE0_SA_RDY   = 1;                     /* trigger operation */

		/* write input */
		input = (unsigned long *)pREG_PKTE0_DATAIO_BUF;
		for (i=0; i<(128/32); i++)
			input[i] = riB[i];

		/* set input buffer count.  the count needs to be rounded up length to **next** multiple of 4 if not already a mult of 4*/
		*pREG_PKTE0_INBUF_CNT = 16;

		/* poll status */
		stat = *pREG_PKTE0_STAT;
		while((stat & 0x200) == 0){
			for(i=0; i<100; i++);
			stat = *pREG_PKTE0_STAT;
		}


		/* collect output and acknowledge */
		output    = (unsigned long *)pREG_PKTE0_DATAIO_BUF;
		outputCnt = *pREG_PKTE0_STAT;
		outputCnt = (outputCnt & 0xffc00000) >> 22;    /* get number of words available */

		for(i=0; i<outputCnt; i++)
			sB[i] = *output++;

		*pREG_PKTE0_OUTBUF_CNT = outputCnt * 4;        /* acknowledge how many bytes were read from buffer */

		/* clean up */
		resStat = *pREG_PKTE0_CTL_STAT;
		len     = *pREG_PKTE0_LEN;
		*pREG_PKTE0_RDSC_CNT = 1;                      /* allows engine to accept new cmd desc's */

		do{
			bool carry_started = false;
			/* increase dt */
			k = 15;
			if(dtBuff[15] == 0xff){
				//carry_started = true;
				dtBuff[15] = 0;
				lastK = 15;
				for(k=14; k>=0; k--){
					if(dtBuff[k] == 0xff && k == lastK-1)
						dtBuff[k] = 0;
					else
						break;
				}

			}

			dtBuff[k] += 1;

		}while(0);


	} // j

	fprintf(outfp, "R = ");
	for(k=0; k<128/8; k++)
		fprintf(outfp, "%02x", randBuff[k]);
	fprintf(outfp, "\n\n");

	return 0;
}

